#sendMail
#Usage: email < message >. Where < message > is your message to admin.
#By Kissa2k

package sendMail;

use strict;
use IO::Socket;
use Plugins;
use Commands;
use Globals;
use Utils;
use Log qw(message error warning);

Plugins::register('sendMail', 'Send email messages.', \&Unload, \&Unload);

my $hook = Commands::register(
    ['email','Send email messages.',\&mail]
);

sub Unload {
	Commands::unregister($hook);
}

#Function for encoding string to base64
sub encode_base64 ($;$)
{
    if ($] >= 5.006) {
	require bytes;
	if (bytes::length($_[0]) > length($_[0]) ||
	    ($] >= 5.008 && $_[0] =~ /[^\0-\xFF]/))
	{
	    require Carp;
	    Carp::croak("The Base64 encoding is only defined for bytes");
	}
    }

    use integer;

    my $eol = $_[1];
    $eol = "\n" unless defined $eol;

    my $res = pack("u", $_[0]);
    # Remove first character of each line, remove newlines
    $res =~ s/^.//mg;
    $res =~ s/\n//g;

    $res =~ tr|` -_|AA-Za-z0-9+/|;               # `# help emacs
    # fix padding at the end
    my $padding = (3 - length($_[0]) % 3) % 3;
    $res =~ s/.{$padding}$/'=' x $padding/e if $padding;
    # break encoded string into lines of no more than 76 characters each
    if (length $eol) {
	$res =~ s/(.{1,76})/$1$eol/g;
    }
    return $res;
}

sub trim {
    my($string)=@_;
    for ($string) {
        s/^\s+//;
        s/\s+$//;
        }
    return $string;
}

sub mail {
	my (undef, $args) = @_;
	my @args = split(/ /, $args);
	my $from=$config{sendMailUser};
	my $email=encode_base64($config{sendMailUser});
	my $pass=encode_base64($config{sendMailPass});
	my $to=$config{sendMailAdmin};
	my $sock;
	my $data;
	my $message;
	if($args[0] ){
		#Making socket to send message
		while(!$sock){
		$sock = new IO::Socket::INET(
				PeerAddr => $config{sendMailSMTP},
				PeerPort => $config{sendMailSMTPPort},
				Proto => 'tcp');
		}
		print $sock "HELO $config{sendMailSMTP}\n";
		$data=<$sock>;
		print $sock "AUTH LOGIN\n";
		$data.=<$sock>;
		print $sock "$email";
		$data.=<$sock>;
		print $sock "$pass";
		$data.=<$sock>;
		print $sock "MAIL FROM:$from\n";
		$data.=<$sock>;
		print $sock "RCPT TO:$to\n";
		$data.=<$sock>;
		print $sock "DATA\n";
		$data.=<$sock>;
		print $sock "Subject: From OpenKore\n";
		print $sock "X-Mailer: OpenKore\n";
		print $sock "X-MSMail-Priority: Normal\n";
		for(my $i=0; $i<=@args; $i++){
			$message=$message." ".$args[$i];
		}
		$message=trim($message);
		print $sock "$message \n";
		print $sock ".\n";
		$data.=<$sock>;
		print $sock "QUIT\n";
		$data.=<$sock>;
		if($config{sendMailDebug} eq 1){ print $data};
		if($data=~"You have exceeded message sending limit"){
			message("You have exceeded message sending limit! Please wait 15 or more minutes.\n","info");
		}else{
			message("Your mail message has been sent!\n","info");
		}
	}else{
		message("Syntax Error in function 'email'\nUsage: email < message >\nWhere < message > is your message to admin.\n","info");	
	}
}

return 1;
